﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private B4XTable1 As B4XTable
	Public PrefDialog As PreferencesDialog
	Private xui As XUI
	Private editCol As B4XTableColumn
	Private const CSVFile As String = "table.csv"
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	
	
	Root.LoadLayout("1")
	xui.SetDataFolder("TableAndForms")  'for B4J
	If File.Exists(xui.DefaultFolder, CSVFile) = True Then
		File.Delete(xui.DefaultFolder,CSVFile)  'for testing we want to delet file every once in a while
	End If
	If File.Exists(xui.DefaultFolder, CSVFile) = False Then
		Wait For (File.CopyAsync(File.DirAssets, CSVFile, xui.DefaultFolder, CSVFile)) Complete (Success As Boolean)
		Log($"CSV file Copied = ${Success}"$)
	End If
	
	setuptable
End Sub

Sub setuptable
	B4XTable1.Clear
	editCol = B4XTable1.AddColumn("Edit", B4XTable1.COLUMN_TYPE_TEXT)
	editCol.Sortable = False
	editCol.Width = 300dip
	B4XTable1.RowHeight = 75dip
	B4XTable1.NumberOfFrozenColumns = 1
	B4XTable1.AddColumn("Type", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable1.AddColumn("Name", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable1.AddColumn("Birth Date", B4XTable1.COLUMN_TYPE_DATE)
	B4XTable1.AddColumn("Sex", B4XTable1.COLUMN_TYPE_TEXT)
	LoadData
	PrefDialog.Initialize(Root, "Editable Table", 500dip, 500dip)
'	PrefDialog.Initialize(Root, "Editable Table", 300dip, 300dip) 'orig
	PrefDialog.LoadFromJson(File.ReadString(File.DirAssets, "template.json"))
	PrefDialog.SetOptions("Type", File.ReadList(File.DirAssets, "animals.txt"))
	PrefDialog.SearchTemplate.MaxNumberOfItemsToShow = 300
	B4XTable1.MaximumRowsPerPage = 20
	B4XTable1.BuildLayoutsCache(B4XTable1.MaximumRowsPerPage)
	Sleep(0)
	For i = 1 To editCol.CellsLayouts.Size - 1
		Dim p As B4XView = editCol.CellsLayouts.Get(i)
		Dim LayoutParent As B4XView = xui.CreatePanel("")
		p.AddView(LayoutParent, 0, 0, p.Width, p.Height)
		LayoutParent.LoadLayout("items")
	Next
	B4XTable1_DataUpdated

End Sub


Private Sub B4XPage_Background
	ExportTableToCSV
End Sub

Sub LoadData
	Dim data As List
	If File.Exists(xui.DefaultFolder, CSVFile) Then
		Dim su As StringUtils
		data = su.LoadCSV(xui.DefaultFolder, CSVFile, ",")
	Else
		data.Initialize
	End If
	B4XTable1.SetData(data)
End Sub

Sub SwiftDel_Click
	Dim RowId As Long = GetRowId(Sender)
	Dim Item As Map = B4XTable1.GetRow(RowId)
	Dim sf As Object = xui.Msgbox2Async($"Delete item: ${Item.Get("Name")}?"$, "", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		B4XTable1.sql1.ExecNonQuery2("DELETE FROM data WHERE rowid = ?", Array(RowId))
		B4XTable1.UpdateTableCounters
	End If
B4XTable1.Refresh
End Sub

Sub SwiftEdit_Click
	'Sub btnEdit_Click
	Dim RowId As Long = GetRowId(Sender)
	Dim Item As Map = B4XTable1.GetRow(RowId)
	ShowDialog(Item, RowId)
	
End Sub

Sub SwiftDuplicate_Click
	'Sub btnDuplicate_Click
	Dim RowId As Long = GetRowId(Sender)
	Dim Item As Map = B4XTable1.GetRow(RowId)
	ShowDialog(Item, 0) 'RowId = 0 means that a new item will be created
End Sub

Sub GetRowId (View As SwiftButton) As Long   'mahares modified
	Log(View.mBase.As(B4XView).Parent.Parent.TAG) 'MAGMA
	Dim RowIndex As Int = View.mBase.As(B4XView).Parent.Parent.TAG'editCol.CellsLayouts.IndexOf(View.mBase.As(B4XView).Parent.TAG)  'mahares/MAGMA :-)
'	Log(RowIndex)
'	Dim RowIndex As Int = editCol.CellsLayouts.IndexOf(View.Parent)  'orig
	Dim RowId As Long = B4XTable1.VisibleRowIds.Get(RowIndex - 1) '-1 because of the header
	Return RowId
End Sub

Private Sub B4XTable1_DataUpdated  'MAGMA
For i = 0 To B4XTable1.VisibleRowIds.Size - 1
	Dim p As B4XView = editCol.CellsLayouts.Get(i + 1)
	p.Tag=I+1 'MAGMA
	If B4XTable1.VisibleRowIds.Get(i) > 0 Then
		Dim p As B4XView = editCol.CellsLayouts.Get(i + 1)
		Dim p2 As B4XView = p
		For Each isb As B4XView In p2.GetAllViewsRecursive
			isb.Visible=True
		Next
	Else
		Dim p As B4XView = editCol.CellsLayouts.Get(i + 1)
		Dim p2 As B4XView = p
		For Each isb As B4XView In p2.GetAllViewsRecursive
			isb.Visible=False
		Next

	End If
Next

End Sub

Private Sub ShowDialog(Item As Map, RowId As Long)
	Wait For (PrefDialog.ShowDialog(Item, "OK", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Dim params As List
		params.Initialize
		params.AddAll(Array(Item.Get("Type"), Item.Get("Name"), Item.Get("Birth Date"), Item.Get("Sex"))) 'keys based on the template json file
		If RowId = 0 Then 'new row
			B4XTable1.sql1.ExecNonQuery2($"INSERT INTO data VALUES("", ?, ?, ?, ?)"$, params)
			B4XTable1.ClearDataView
			B4XTable1.Refresh
			B4XTable1_DataUpdated
		Else
			params.Add(RowId)
			'first column is c0. We skip it as this is the "edit" column
			B4XTable1.sql1.ExecNonQuery2("UPDATE data SET c1 = ?, c2 = ?, c3 = ?, c4 = ? WHERE rowid = ?", params)
			B4XTable1.Refresh
			B4XTable1_DataUpdated
		End If
	End If
End Sub

Sub btnAdd_Click
	ShowDialog(CreateMap(), 0)
End Sub

Public Sub ExportTableToCSV
	Dim data As List
	data.Initialize
	Dim rs As ResultSet = B4XTable1.sql1.ExecQuery("SELECT * FROM data")
	Do While rs.NextRow
		Dim row(B4XTable1.Columns.Size) As String
		For i = 0 To B4XTable1.Columns.Size - 1
			Dim c As B4XTableColumn = B4XTable1.Columns.Get(i)
			row(i) = rs.GetString(c.SQLID)
		Next
		data.Add(row)
	Loop
	rs.Close
	Dim su As StringUtils
	su.SaveCSV(xui.DefaultFolder, CSVFile, ",", data)
End Sub

Public Sub btnExport_Click
	Dim data As List
	data.Initialize
	Dim rs As ResultSet = B4XTable1.sql1.ExecQuery("SELECT * FROM data")
	Do While rs.NextRow
		Dim row(B4XTable1.Columns.Size) As String
		For i = 0 To B4XTable1.Columns.Size - 1
			Dim c As B4XTableColumn = B4XTable1.Columns.Get(i)
			row(i) = rs.GetString(c.SQLID)
		Next
		data.Add(row)
	Loop
	rs.Close
	Dim su As StringUtils
	su.SaveCSV(xui.DefaultFolder, CSVFile, ",", data)
End Sub

Sub B4XTable1_CellClicked (ColumnId As String, RowId As Long)
	Dim column As B4XTableColumn = B4XTable1.GetColumn(ColumnId)
	Log(column.SQLID)  'column name referred to as c0 for foirst table col, c1 for 2nd, c3 for third and so on
	Log(ColumnId)
	Dim value As String = B4XTable1.GetRow(RowId).Get(ColumnId)
	Log($"col: ${ColumnId}    value: ${value}"$  )   'name of column clicked and content of cell clicked in colum
	Log($"rowId: ${RowId}    "$  )   'row number clicked. Note that header cell is 0, then cell 1 then 2, etc.
End Sub

private Sub B4XPage_Resize(Width As Double, Height As Double)
	setuptable
End Sub